<?php

require_once(plugin_dir_path(__FILE__) . 'xwp.php');

class AimeMenu
{

    // Properties

    //constructor
    public function __construct()
    {
        add_action('admin_post_save_aime_settings', array($this, 'handle_aime_settings_form'));
    }

    public function register_menu()
    {
        add_action('admin_menu', array($this, 'add_admin_menu'));
    }


    public function add_admin_menu()
    {
        add_menu_page('Aime Dashboard', 'Aime', 'add_users', 'aime-menu', array($this, 'aime_menu_page'), null, 6);
        add_submenu_page(
            'aime-menu', /* Parent slug */
            esc_html__('Settings', 'aime-menu'), /* Page title */
            esc_html__('Settings', 'aime-menu'), /* Menu title */
            'manage_options', /* Capability */
            'aime-menu-subpage', /* Unique Menu slug */
            array($this, 'aime_settings_menu') /* Callback */
        );
        add_submenu_page(
            'aime-menu', /* Parent slug */
            esc_html__('Connect', 'aime-menu'), /* Page title */
            esc_html__('Connect', 'aime-menu'), /* Menu title */
            'manage_options', /* Capability */
            'aime-menu-connect', /* Unique Menu slug */
            array($this, 'aime_connect_menu') /* Callback */
        );
    }

    function aime_menu_page()
    {

        $aimeSettings = get_option('aime_settings');

?>
        <style>
            .loader {
                width: 48px;
                height: 48px;
                border: 5px solid #FFF;
                border-bottom-color: black;
                border-radius: 50%;
                display: inline-block;
                box-sizing: border-box;
                animation: rotation 1s linear infinite;
            }

            @keyframes rotation {
                0% {
                    transform: rotate(0deg);
                }

                100% {
                    transform: rotate(360deg);
                }
            }
        </style>

        <div id="floating-div" class="floating-box">
            <h1> Aime Dashboard </h1>
        </div>
        <div style="display:flex;flex-direction: row;gap:10px;justify-content: center;">
            <div style="display:flex;flex-direction:column;width:50%">
                <!-- <label for="Token">Token</label> -->
                <input style="height:30px;" type="hidden" id="token" name="token" value="<?php echo $aimeSettings['api_key']; ?>">

            </div>
            <div style="display:flex;flex-direction:column;width:50%">

                <!-- <label for="SpaceId">Space Id</label> -->
                <input style="height:30px" type="hidden" id="SpaceId" name="SpaceId" value="<?php echo $aimeSettings['owner_id']; ?>" />
            </div>
        </div>
        <div style="display:flex;flex-direction: column;gap:10px;margin-top:10px">
            <!-- <label for="topics">Topics</label> -->
            <!-- <input style="height:60px" type="text" id="topics" name="topics" value="war between gaza and israel and was between hezbollah and israel and us involvement"> -->
            <label for="prompt">Prompt</label>
            <input style="height:60px" type="text" id="prompt" name="prompt" value="Make an article from given context on ">


            <div style="display: flex; width: 100%; align-items: center; justify-content: center;margin-top:15px">
                <span id="loader" class="loader" style="display:none"></span>
                <div style="display:flex ;flex-direction:column; gap:10px">
                    <div style="display:flex ;flex-direction:row;gap:10px;justify-content: center; align-items: flex-end;" id="genimagediv">
                        <label for="genimage">Generate Image</label>
                        <input type="checkbox" id="genimage" name="genimage" />
                    </div>
                    <button style="background-color:black; width:140px;height:40px; color:white;border-radius:10px; " id="aime-generate-article" onclick="generateArticle()">Generate Article</button>
                </div>

            </div>
            <div id="article" style="display: none; flex-direction: column; gap: 10px; ">
                <h2>Article</h2>
                <div id="article-content">
                    <textarea id="article-container" style="width: 100%; height: 300px;overflow-auto"></textarea>
                    <div style="display: none; justify-content: center; margin-top: 20px; flex-direction: column; align-items: center;gap:10px ">
                        <label for="title">Title</label>
                        <input type="text" id="title" name="title" style="width:1500px">
                        <label for="tags">Tags</label>
                        <input type="text" id="tags" name="tags" style="width:1500px">
                        <label for="summary">Summary</label>
                        <textarea id="summary" name="summary" style="width:1500px; height:100px"></textarea>
                    </div>
                    <div style="display: flex; justify-content: center; margin-top: 20px;">
                        <button id="save-article" onclick="saveArticle()" style="background-color:black; width:140px;height:35px; color:white;border-radius:10px;display:none">Save Article</button>
                        <!-- <div style="display:none" id="htmlprompt">
            <label for="html_prompt">Html Prompt</label>
            <input style="height:60px" type="text" id="html_prompt" name="html_prompt" value="Make an article from given context on ">
            </div> -->
                        <span id="loader2" class="loader" style="display:none"></span>

                    </div>
                </div>
                <script>
                    async function generateArticle() {
                        document.getElementById("loader").style.display = "block";
                        document.getElementById("aime-generate-article").style.display = "none";
                        document.getElementById("genimagediv").style.display = "none";


                        // let topics = document.getElementById("topics").value;
                        let prompt = document.getElementById("prompt").value;
                        let token = document.getElementById("token").value;
                        let SpaceId = document.getElementById("SpaceId").value;


                        $serverUrl = "<?php echo $aimeSettings['server_url'] ?>/xcmd";
                        const res = await fetch($serverUrl, {
                            method: "POST",
                            headers: {
                                // "authorization": "6cc89773-af2f-4f8c-b3d3-9794bb409675 ec23dc67-6e73-46cf-8152-04f45b67cde8",
                                "authorization": token + " " + SpaceId,
                                "Content-Type": "application/json"
                            },
                            body: JSON.stringify({
                                _module: "conversation-manager",
                                _op: "build-article",
                                _params: {
                                    // _topics: "war between gaza and israel and was between hezbollah and israel and us involvement",          
                                    // _prompt: "Make an article from given context on "
                                    // _topics: topics,
                                    _prompt: prompt
                                }
                            })
                        })
                        const data = await res.json();

                        document.getElementById("loader").style.display = "none";
                        document.getElementById("aime-generate-article").style.display = "block";
                        document.getElementById("genimagediv").style.display = "block";
                        document.getElementById("save-article").style.display = "block";
                        // click element document.getElementById("save-article")



                        if (!data._result) {
                            alert("Error:" + data.message);
                            document.getElementById("save-article").style.display = "none";

                        } else {
                            document.getElementById("article-container").value = data._result._content;
                            document.getElementById("tags").value = data._result._tags;
                            document.getElementById("title").value = data._result._title;
                            document.getElementById("summary").value = data._result._summary;
                            document.getElementById("save-article").click();


                        }
                    }
                    async function saveArticle() {

                        document.getElementById("loader2").style.display = "block";
                        document.getElementById("save-article").style.display = "none";

                        let data = document.getElementById("article-container").value;
                        let token = document.getElementById("token").value;
                        let SpaceId = document.getElementById("SpaceId").value;
                        let title = document.getElementById("title").value;
                        let tags = document.getElementById("tags").value;
                        let summary = document.getElementById("summary").value;
                        // const res_html = await fetch($serverUrl,{
                        //     method: "POST",
                        //     headers: {
                        //         // "authorization": "6cc89773-af2f-4f8c-b3d3-9794bb409675 ec23dc67-6e73-46cf-8152-04f45b67cde8",
                        //         "authorization": token + " " + SpaceId,
                        //         "Content-Type": "application/json"
                        //     },



                        //     body : JSON.stringify({
                        //         _module: "conversation-manager",
                        //         _op: "construct_html",
                        //         _params: {         
                        //             _prompt:"create html from  the given content",
                        //             _text: data
                        //         }
                        //     })                        
                        // })
                        // const ccontent = await res_html.json();


                        let post = {
                            _channel_id: "14424e00-d50e-46fa-96eb-4fd7272b40fe",
                            _title: title,
                            _content: data,
                            //    _content:ccontent._result,
                            _status: 'draft',
                            _author: 1,
                            _categories: [1],
                            _tags: tags,
                            _excerpt: summary,

                        }

                        const res = await fetch($serverUrl, {
                            method: "POST",
                            headers: {
                                // "authorization": "6cc89773-af2f-4f8c-b3d3-9794bb409675 ec23dc67-6e73-46cf-8152-04f45b67cde8",
                                "authorization": token + " " + SpaceId,
                                "Content-Type": "application/json"
                            },



                            body: JSON.stringify({
                                _module: "wordpress-manager",
                                _op: "add_post",
                                _params: post
                            })
                        })
                        const ddata = await res.json();


                        if (!ddata._result) {
                            alert("Error:" + ddata.message);
                            document.getElementById("loader2").style.display = "none";
                            document.getElementById("save-article").style.display = "block";
                        } else {
                            // alert("Article Saved Successfully");
                            let post_id = ddata._result._post_id;
                            document.getElementById("loader2").style.display = "none";
                            document.getElementById("save-article").style.display = "block";
                            // redirect to the post page in edit mode
                            window.location.href = "<?php echo get_site_url() ?>/wp-admin/post.php?post=" + post_id + "&action=edit";

                            // document.getElementById("htmlprompt").style.display = "block";
                        }

                    }
                </script>
            </div>
        <?php
    }

    function aime_settings_menu()
    {
        $xscript = plugin_dir_url(__FILE__) . '../js/admin.js';
        //load settings from wordpress options
        $aime_settings = get_option('aime_settings');
        if (!$aime_settings) {
            $aime_settings = array();
            $aime_settings['api_key'] = 'no-key';
            $aime_settings['owner_id'] = '';
            $aime_settings['server_url'] = 'https://play.aimeverse.com';
            $aime_settings['first_name'] = '';
            $aime_settings['last_name'] = '';
        }



        ?>
            <script type="module" src="<?php echo $xscript ?>" defer> </script>
            <div id="floating-div" class="floating-box">
                <h1>Aime Web Manager Settings</h1>
                <form id="aime-settings-form" method="post" action="<?php echo admin_url('admin-post.php'); ?>">
                    <input type="hidden" name="action" value="save_aime_settings">
                    <?php wp_nonce_field('aime_settings_nonce', 'aime_settings_nonce_field'); ?>
                    <div style="display:grid;gap:10px">

                        <div style="display:grid-column-start:0;">
                            <label for="api_key" style="width:100px;display:inline-block">API Key</label>
                            <input type="text" id="api_key" name="api_key" style="width:250px;display:inline-block" value="<?php echo $aime_settings['api_key']; ?>">
                        </div>
                        <div>
                            <label for="owner_id" style="width:100px;display:inline-block">Owner ID</label>
                            <input type="text" id="owner_id" name="owner_id" style="width:250px;display:inline-block" value="<?php echo $aime_settings['owner_id']; ?>">
                        </div>
                        <div style="display:grid-column-start:0;">
                            <label for="server_url" style="width:100px;display:inline-block">Aime Server</label>
                            <input type="text" id="server_url" style="width:250px;display:inline-block" name="server_url" value="<?php echo $aime_settings['server_url']; ?>">
                        </div>
                        <div style="display:grid-column-start:0;">
                            <label for="first_name" style="width:100px;display:inline-block">First Name</label>
                            <input type="text" id="first_name" style="width:250px;display:inline-block" name="first_name" value="<?php echo $aime_settings['first_name']; ?>">
                        </div>
                        <div style="display:grid-column-start:0;">
                            <label for="last_name" style="width:100px;display:inline-block">Last Name</label>
                            <input type="text" id="last_name" style="width:250px;display:inline-block" name="last_name" value="<?php echo $aime_settings['last_name']; ?>">
                        </div>
                        <div style="display:grid-column-start:0;">
                            <label for="channel_id" style="width:100px;display:inline-block">channel id</label>
                            <input type="text" id="channel_id" style="width:250px;display:inline-block" name="channel_id" value="<?php echo $aime_settings['channel_id']; ?>">
                        </div>
                   
                        <div style="display:grid-column-start:0;">
                            <input type="submit" value="Save">
                        </div>
                    </div>
                </form>
            </div>
            <?php
            if (isset($_GET['status']) && $_GET['status'] == 'success') {
                echo '<div class="notice notice-success is-dismissible"><p>Settings saved successfully!</p><p>OK :)</p></div>';
            }
        }


        // function get_aime_scripts_urls() {
        //     $aime_public_folder = plugin_dir_url(__FILE__) . '../client-lib/aime-wp-js/';

        //     return array(
        //         'aime_public_folder' => $aime_public_folder,
        //         'aime_script' => $aime_public_folder .  'aime-wp-js.es.js',
        //         'xpell_script' => plugin_dir_url(__FILE__) . '../client-lib/xpell/xpell.es.js'
        //     );

        // }

        function aime_connect_menu()
        {

            global $_xwp;

            $scripts = $_xwp->get_aime_scripts_urls();
            
            // $aime_public_folder = plugin_dir_url(__FILE__) . '../client-lib/aime-wp-js/';
            // $aime_script = $aime_public_folder. 'aime-wp-js.es.js';
            // $xpell_script = plugin_dir_url(__FILE__) . '../client-lib/xpell/xpell.es.js';
            //load settings from wordpress options
            $aime_settings = get_option('aime_settings');
            if (!$aime_settings) {
                $aime_settings = array();
                $aime_settings['api_key'] = 'no-key';
                $aime_settings['owner_id'] = '';
                $aime_settings['server_url'] = 'https://play.aimeverse.com';
                $aime_settings['first_name'] = '';
                $aime_settings['last_name'] = '';
                $aime_settings['channel_id'] = '';
            }



            ?>
            <div id="aime-container" class="aime-view-container">
            </div>
            
            <script type="module" defer>
                
                import {start} from '<?php echo $scripts['aime_script'] ?>';
                
                const serverSettings ={
                    _token: undefined,
                    _verbose: true,
                    _player_id: "xplayer",
                    _player_class: "xplayer",
                    _player_parent: "aime-container",
                    _theme: "dark",
                    _public_folder:"<?php echo $scripts['aime_public_folder']?>",
                    _wp_user_id: "string",
                    _wp_user_email: "string",
                    _wp_site_url: "string",
                    _wp_site_name: "string",
                    _wp_site_description: "string",
                    _wp_site_icon: "string",
                }
                
                start(serverSettings); //start the aime-connect app
            </script>
    <?php
            if (isset($_GET['status']) && $_GET['status'] == 'success') {
                echo '<div class="notice notice-success is-dismissible"><p>Settings saved successfully!</p><p>OK :)</p></div>';
            }
        }



        function handle_aime_settings_form()
        {
            // Verify nonce for security
            if (
                !isset($_POST['aime_settings_nonce_field']) ||
                !wp_verify_nonce($_POST['aime_settings_nonce_field'], 'aime_settings_nonce')
            ) {
                error_log('Security check failed');
                wp_die('Security check failed');
            }

            // Check if the user has the capability to manage options
            if (!current_user_can('manage_options')) {
                error_log('Unauthorized user');
                wp_die('Unauthorized user');
            }

            // Sanitize and save the API key
            $api_key = sanitize_text_field($_POST['api_key']);
            $server_url = sanitize_text_field($_POST['server_url']);
            
            $aime_settings = array(
                'api_key' => $api_key,
                "server_url" => $server_url,
                'owner_id' => sanitize_text_field($_POST['owner_id']),
                'first_name' => sanitize_text_field($_POST['first_name']),
                'last_name' => sanitize_text_field($_POST['last_name']),
                'channel_id' => sanitize_text_field($_POST['channel_id'])
                
            );
            

            // Update the option in the database
            update_option('aime_settings', $aime_settings);


            // Redirect to the settings page with a success message
            wp_redirect(add_query_arg('status', 'success', admin_url('admin.php?page=aime-menu-subpage')));
            exit();
        }

        // function create_token()
        // {
        //     $secret = "aime1234";

        //     $payload = array(
        //         "iss" => "http://example.org",
        //         "aud" => "http://example.com",
        //         "iat" => 1356999524,
        //         "nbf" => 1357000000
        //     );

        //     $jwt = JWT::encode($payload, $secret, 'HS256');
        //     return $jwt;
        // }
    }

    ?>