<?php
/** Xpell Application - Wordpress plugin entry point*/

// MyLibrary.php
require_once(plugin_dir_path(__FILE__) . 'aime-agent.php');
require_once(plugin_dir_path(__FILE__) . 'aime-menu.php');
require_once(plugin_dir_path(__FILE__) . 'xwp.php');
require_once(plugin_dir_path(__FILE__) . 'post-manager.php');
require_once(plugin_dir_path(__FILE__) . 'comment-manager.php');
require_once(plugin_dir_path(__FILE__) . 'user-manager.php');
require_once(plugin_dir_path(__FILE__) . 'page-manager.php');

class XApp {

    //properties
    private $_agent = null;
    private $_menu = null;
    public $_pm = null;
    public $_cm = null;
    public $_um = null;
    public $_page_manager = null;




    public function __construct() {
        // Constructor
        $this->_agent = new AimeAgent();
        $this->_menu = new AimeMenu();
        $this->_pm = new PostManager();
        $this->_cm = new CommentManager();
        $this->_um = new UserManager();
        $this->_page_manager = new PageManager();
    }


    
    
    public function run() {
        // run the application
        // make _xwp global (XWP -> Xpell Wordpress Helper)
        global $_xwp;
        $this->_menu->register_menu();
        add_action('wp_enqueue_scripts', array($_xwp,'import_css'));
        add_action('admin_enqueue_scripts', array($_xwp,'import_css'));
        add_action('admin_enqueue_scripts', array($_xwp,'add_aime_scripts'));

        add_action('rest_api_init', array($this,'register_apis'));
        // add_action('wp_footer', array($_xwp, 'load_xpell_js'));
        add_action('manage_posts_extra_tablenav', array($_xwp,'add_custom_button_to_post_list'));
        add_action('enqueue_block_editor_assets', array($_xwp,'aime_plugin_enqueue_scripts'));
        
    }

    public function register_apis() {
        $this->_pm->register_apis();
        $this->_cm->register_apis();
        $this->_um->register_apis();
        $this->_page_manager->register_apis();
    }
}



