<?php
// Xpell Wordpress Helper

//const
define("PLUGIN_BASE_ROUTE", 'aime/v1');

class XWP {
    //static 
    public function get_plugin_dir() {
        return plugin_dir_path(__FILE__);
    }
    
    public function get_plugin_url() {
        return plugin_dir_url(__FILE__);
    }

    public function register_route($route, $callback) {
        register_rest_route( PLUGIN_BASE_ROUTE , '/' . $route . '/', array(
            'methods' => 'POST',
            'callback' => $callback,
            'permission_callback' => '__return_true', // Adjust for authentication if needed
        ));
    }

    public function import_css() {
        wp_enqueue_style(
            'xpell-style', // Handle name for the stylesheet
            $this->get_plugin_url() .'../client-lib/xpell/xpell.css', // URL of the stylesheet
            array(), // Dependencies, if any (e.g., other styles)
            '1.0.0', // Version of the stylesheet (optional)
            'all' // Media type (optional, default is 'all')
        );
        wp_enqueue_style(
            'aime-style', // Handle name for the stylesheet
            $this->get_plugin_url() .'../client-lib/aime-wp-js/aime-style.css', // URL of the stylesheet
            array(), // Dependencies, if any (e.g., other styles)
            '1.0.0', // Version of the stylesheet (optional)
            'all' // Media type (optional, default is 'all')
        );
       
       
        // <link rel="stylesheet" type="text/css" href="<?php echo $this->get_plugin_url() . '../css/xpell.css'; ">
        //<link rel="stylesheet" type="text/css" href="<?php echo $this->get_plugin_url() . '../css/aime-style.css'; ">
       
    }

    public function load_xpell_js() {
        $xscript = $this->get_plugin_url()  . '../js/main.js'
        ?>
        <script type="module" src="<?php echo $xscript ?>" defer title="Xpell.AI by Aime Technologies"></script>
        <?php
    }

    function add_custom_button_to_post_list() {
        $screen = get_current_screen();
        // Check if we are on the post list page
        if ($screen->post_type == 'post') {
            // Output the button next to "Add New Post"
            echo '<a href="?page=aime-menu"  class="button button-primary" style="margin-left: 10px;">Generate with AIME</a>';
        }
    }
    // page=aime-menu
    


    function add_aime_scripts() {
        global $_xwp;

        $scripts = $_xwp->get_aime_scripts_urls();
        $aime_settings = get_option('aime_settings');
        // print aime settings
       

        ?>
        <!-- <script type="module" src="<?php echo $scripts['aime_script'] ?>" defer title="Aime Technologies"></script> -->
        <!-- <script type="module" src="<?php echo $scripts['xpell_script'] ?>" defer title="Xpell.AI by Aime Technologies"></script> -->
       
       <script type="module" >
            import { _xd ,_x,XUI,XDB} from "<?php echo $scripts['xpell_script'] ?>";
            
            _xd._o["aime_public_folder"] = "<?php echo $scripts['aime_public_folder'] ?>";
            _xd._o["server-settings"]= {
                    _token: undefined,
                    _verbose: true,
                    _player_id: "xplayer",
                    _player_class: "xplayer",
                    _player_parent: "aime-container",
                    _theme: "dark",
                    _public_folder:"<?php echo $scripts['aime_public_folder']?>",
                    _wp_user_id: "string",
                    _wp_user_email: "string",
                    _wp_site_url: "string",
                    _wp_site_name: "string",
                    _wp_site_description: "string",
                    _wp_site_icon: "string",
                    _channel_id: "<?php echo $aime_settings['channel_id'] ?>",
                }
            // _x.start();
             _x.verbose = true;
            // _x.info()
            XDB.info();
            XDB.encode = true;

            _x.loadModules(XUI);
            _x.start();

            
        </script>
        <?php
    }

    function aime_plugin_enqueue_scripts() {        

        // wp_register_script('aime-custom-gutenberg-script', plugin_dir_url(__FILE__) . '../js/aime-editor.js');
        wp_enqueue_script_module(
            'aime-custom-gutenberg-script',
            plugin_dir_url(__FILE__) . '../js/aime-editor.js', // Path to your JS file
            array('wp-blocks', 'wp-element', 'wp-edit-post', 'wp-data', 'wp-plugins', 'wp-components', 'wp-i18n'), // Gutenberg dependencies
            filemtime(plugin_dir_path(__FILE__) . '../js/aime-editor.js'), // Cache-busting
            "1.2" // Version number
        );

 
        
        // wp_script_add_data('aime-custom-gutenberg-script', 'type', 'module');


    }    
    
    function get_aime_scripts_urls() {
        $aime_public_folder = plugin_dir_url(__FILE__) . '../client-lib/aime-wp-js/';

        return array(
            'aime_public_folder' => $aime_public_folder,
            'aime_script' => $aime_public_folder .  'aime-wp-js.es.js',
            'xpell_script' => plugin_dir_url(__FILE__) . '../client-lib/xpell/xpell.es.js'
        );
    }

    

     
    
}




$_xwp = new XWP();

?>
